/* the checker has three arguments:
   - first - name of the input file
   - second - name of the correct output file
   - third - name of the contestant output file */
#include<iostream>
#include<fstream>
#include<string>
#include<math.h>
#define eps 1e-3
using namespace std;
void output_message (double points, string message) {
    cout << points << endl ;
    cerr << message << endl ;
    exit(0);
}
int main (int argc, char** argv) {
    ifstream inp,ans,out;
    if (argc<4) output_message(0,"The checker needs input file, correct output and contestant output!");
    inp.open(argv[1]);
    if (inp.is_open()==false) output_message(0,"Could not open input file!");
    ans.open(argv[2]);
    if (ans.is_open()==false) output_message(0,"Could not open correct output file!");
    out.open(argv[3]);
    if (out.is_open()==false) output_message(0,"Could not open contestant output file!");

    for (;;) {
        double num_ans,num_out;
        if (!(ans >> num_ans)) break;
        if (!(out >> num_out)) output_message(0,"Could not read output!");
        if (fabs(num_ans-num_out)>=eps) output_message(0,"Wrong answer!");
        if (!(fabs(num_ans-num_out)<eps)) output_message(0,"Wrong answer!"); /// handle nan case
    }
    char tmp;
    if (out >> tmp) output_message(0,"Extra output!");
    output_message(1,"OK!");
    cout << endl ;
    return 0;
}

