/* the core program has three arguments:
   - first - state of checking with three possible values:
              = 0 - checks the solution file according the answer file
              = x>0 - generates solution file with name from the third argument using the x-th solution
   - second - name of the input file
   - third - name of the file to be checked or generated
   - fourth - name of the correct output file (optional - only for option 0) */
#include<iostream>
#include<iomanip>
#include<string>
#include<vector>
#include<math.h>
#include "checker_tgen.h"
using namespace std;


int main (int argc, char** argv) {
    ifstream inp,out,ans;
    vector <string> solutions={
        "signs_23p",
        "signs_37p",
        "signs_100p"
    };
    check_arguments(argc,argv,inp,out,ans,solutions,"");
    inp.close();
    for (int i=1; ; i++) {
        double ans_out,ans_sol;
        if (!(ans >> ans_sol)) break;
        out >> ans_out ;
        if (fabs(ans_out-ans_sol)>1e-3) {
            cout << "WA!\n" << std::fixed << std::setprecision(6) << i << " " << ans_out << " " << ans_sol ;
            exit(0);
        }
    }
    char tmp;
    if (out >> tmp) cout << "Extra output!\n";
    cout << "OK!\n";
    /*string command="..\\checker\\checker "+string(argv[2])+" "+string(argv[4])+" "+string(argv[3]);
    system(command.c_str());*/
    cout << endl ;
    return 0;
}
