#include "testlib.h"
#include<iostream>
#include<vector>
#define MAXN 100000
#define MAXQ 100000
#define MAXD 1000000000
using namespace std;
void error_message (const char message[]) {
    cerr << "Error - " << message << "\n";
    exit(0);
}
int dist[MAXN],signs[MAXN];
int balance[MAXN],suff[MAXN];
int main (int argc, char* argv[]) {
    if (argc==1) error_message("the test validator needs arguments!\n");
    FILE* fin;
    fin=fopen(argv[1],"r");
    if (fin==NULL) error_message("wrong test name!");
    fclose(fin);
    freopen(argv[1],"r",stdin);
    registerValidation(argc,argv);

    int n=inf.readInt(1,MAXN,"N"); inf.readSpace();
    int l=inf.readInt(1,MAXD,"L"); inf.readEoln();
    int prv=0;
    for (int i=0; i<n; i++) {
        dist[i]=inf.readInt(1,MAXD,"di"); inf.readSpace();
        signs[i]=inf.readInt(-1,119,"si"); inf.readEoln();
        ensuref(prv<dist[i],"Distances don't form increasing sequence!\n");
        ensuref((signs[i]==-1)||((signs[i]>=10)&&(signs[i]<=119)),"Invalid sign!\n");
        prv=dist[i];
    }
    ensuref(dist[n-1]<l,"Last distance bigger than length!\n");

    vector <int> active;
    active.push_back(120);
    for (int i=0; i<n; i++) {
        balance[i]=active.size();
        if (signs[i]==-1) {
            active.pop_back();
            ensuref(!active.empty(),"Too many undos!\n");
        }
        active.push_back(signs[i]);
    }
    suff[n]=1e9;
    for (int i=n-1; i>=0; i--) {
        suff[i]=min(balance[i],suff[i+1]);
    }

    int q=inf.readInt(1,MAXQ,"Q"); inf.readEoln();
    bool types[4]={false, false, false, false};
    int minp=n;
    for (int i=0; i<q; i++) {
        int pos=inf.readInt(1,n); inf.readSpace();
        int sign=inf.readInt(-1,119); inf.readEoln();
        ensuref((sign==-1)||((sign>=10)&&(sign<=119)),"Invalid sign in queries!\n");
        pos--;
        if (sign==-1) ensuref(suff[pos]>1,"Too many undos in queries!\n");
        if ((signs[pos]!=-1)&&(sign!=-1)) types[0]=true;
        if ((signs[pos]!=-1)&&(sign==-1)) types[1]=true;
        if ((signs[pos]==-1)&&(sign!=-1)) types[2]=true;
        if ((signs[pos]==-1)&&(sign==-1)) types[3]=true;
        minp=min(minp,pos);
    }
    inf.readEof();

    cout << n << " " << q << " " << minp << " " << types[3] << endl ;
    if ((n<=5e3)&&(q<=5e3)) cout << "First subtask!\n";
    else if ((n<=MAXN)&&(q<=1e4)&&(n-minp<=2000)) cout << "Second subtask!\n";
    else if ((n<=MAXN)&&(q<=MAXQ)&&((types[1]|types[2]|types[3])==false)) cout << "Third subtask!\n";
    else if ((n<=MAXN)&&(q<=MAXQ)&&((types[0]|types[2]|types[3])==false)) cout << "Fourth subtask!\n";
    else if ((n<=MAXN)&&(q<=MAXQ)&&((types[0]|types[1]|types[3])==false)) cout << "Fifth subtask!\n";
    else if ((n<=MAXN)&&(q<=MAXQ)) cout << "Sixth subtask!\n";
    else cout << "? subtask!\n";
    cout << "Test is OK!\n";
    return 0;
}
